'Sparrow_Reaktionstest.bas


$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 8
$swstack = 4
$framesize = 4



Led1 Alias Portb.1
Led2 Alias Portb.3
S1 Alias Pinb.0
S2 Alias Pinb.2
Config Portb = &B000011010

Dim D As Byte
Dim T As Byte
Dim B As Byte
Dim C As Byte

Declare Sub Receivebinary
Declare Sub Sendbinary

' Timer 0 is configured for Sound at OC0B / PB1
Config Timer0 = Pwm , Prescale = 8 , Compare B Pwm = Clear Up

Do
 Do
 Loop Until S1 = 0                                          'S1 drcken: Start
 Waitms 50
 Do
   Waitms 10
 Loop Until S1 = 1
 Waitms 600
 Do
   T = Rnd(250)                                             'Zufllige Wartezeit
   Waitms T
   Waitms T
 Loop Until S1 = 1
 D = 0
 Led2 = 1                                                   'Startsignal
 Do
   Waitms 10
   D = D + 1                                                'Zeitmessung
 Loop Until S1 = 0
 Led2 = 0
 Waitms 500
 C = D / 10                                                 'Zehner 1/100 s
 Sendbinary
 Waitms 600
 C = D Mod 10                                               'Einner 1/100 s
 Sendbinary
 Waitms 300
Loop



Sub Receivebinary
  C = 0
  B = 1
  Do
     Do
     Loop Until S1 = 0
     Pwm0b = 80
     T = 0
     Do
       Waitms 10
       T = T + 1
     Loop Until S1 = 1
     Pwm0b = 0
     Waitms 10
     If T > 15 Then
        C = C + B
     End If
     Shift B , Left
     T = 0
     Do
       Waitms 10
       T = T + 1
     Loop Until S1 = 0 Or T > 25
  Loop Until T > 25
End Sub

Sub Sendbinary
  Do
    B = C And 1
    If B = 1 Then
      Pwm0b = 80
      Waitms 300
    Else
      Pwm0b = 80
      Waitms 100
    End If
    Pwm0b = 0
    Waitms 100
   Shift C , Right
  Loop Until C = 0
End Sub